// gcc -o makesym makesym.c -lbfd -lgcc -g
#define PACKAGE 1
#define PACKAGE_VERSION 1
#include "bfd.h"
#include <stdio.h>
#include <stdlib.h>

int main()
{
    bfd *abfd;
    asymbol *ptrs[2];
    asymbol *new;

    abfd = bfd_openw("foo","elf64-x86-64");
    bfd_set_format(abfd, bfd_object);
    bfd_default_set_arch_mach(abfd, bfd_arch_i386, bfd_mach_x86_64);
    new = bfd_make_empty_symbol(abfd);
    new->name = "main";
    new->section = bfd_make_section_with_flags(abfd, ".text", SEC_HAS_CONTENTS);
    new->flags = BSF_GLOBAL;
    new->value = 0;

    ptrs[0] = new;
    ptrs[1] = (asymbol *)0;

    unsigned char text_content[10];
    int text_size = 10;
    text_content[0] = 0x48; // "mov rdi, 0"  (exit status 0)
    text_content[1] = 0x31; // "xor rsi, rsi"
    text_content[2] = 0xc0; // "xor rdx, rdx"
    text_content[3] = 0x48;
    text_content[4] = 0x83; // "call 0x60"
    text_content[5] = 0x3e; // Exit syscall number 60 (0x3e)
    text_content[6] = 0x0f;
    text_content[7] = 0x05; // syscall instruction

    // Important: this needs to be before set section contents!
    bfd_set_symtab(abfd, ptrs, 1);

    bfd_set_section_size(new->section, text_size);
    int res = bfd_set_section_contents(abfd, new->section, text_content, 0, text_size);
    printf("result of filling new section: %d\n", res);

    bfd_close(abfd);
    return 0;
}
